BSCAllianceRanking = BSCAllianceRanking or {}
local BSCARI = BSCAllianceRanking

BSCARI.Name = "BSCs-AllianceRanking"
BSCARI.NameSpaced = "BSCs-Alliance Rankin/Point Info"
BSCARI.Author = "@BloodStainChild666"
BSCARI.Version = 1
BSCARI.SavedVar = "BSCAllianceRankingSaved"
BSCARI.NameMenu = "BSCs-AllianceRankin"
BSCARI.VersionDisplay = "1.1.2"

BSCARI.CurrentCharID = -1

-- Saved Vars
local defaultSavedVarsAccount = { 
	CHAR_LIST = {},
	SETTING = {},
	cooldownRotWTime = 0,
}

local ENABLED_STATE = 1
local DISABLED_STATE = 0.5

-------------------------------------------------------------------------------------------------------------------------------------------------
local CAMPAIGN_OVERVIEW_TYPE_SCORING = 1
local CAMPAIGN_OVERVIEW_TYPE_BONUSES = 2
local CAMPAIGN_OVERVIEW_TYPE_EMPEROR = 3
local CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_RANKING = 4
local CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_TIER_INFO = 5
local CAMPAIGN_OVERVIEW_TYPE_BG_SYLES = 6

local CAMPAIGN_OVERVIEW_TYPE_INFO =
{
    [CAMPAIGN_OVERVIEW_TYPE_SCORING] = 
    {
        name = GetString(SI_CAMPAIGN_OVERVIEW_CATEGORY_SCORING),
        up = "EsoUI/Art/Campaign/overview_indexIcon_scoring_up.dds",
        down = "EsoUI/Art/Campaign/overview_indexIcon_scoring_down.dds",
        over = "EsoUI/Art/Campaign/overview_indexIcon_scoring_over.dds",
    },
    [CAMPAIGN_OVERVIEW_TYPE_BONUSES] = 
    {
        name = GetString(SI_CAMPAIGN_OVERVIEW_CATEGORY_BONUSES),
        up = "EsoUI/Art/Campaign/overview_indexIcon_bonus_up.dds",
        down = "EsoUI/Art/Campaign/overview_indexIcon_bonus_down.dds",
        over = "EsoUI/Art/Campaign/overview_indexIcon_bonus_over.dds",
        visible = function() return GetAssignedCampaignId() ~= 0 end,
    },
    [CAMPAIGN_OVERVIEW_TYPE_EMPEROR] = 
    {
        name = GetString(SI_CAMPAIGN_OVERVIEW_CATEGORY_EMPERORSHIP),
        up = "EsoUI/Art/Campaign/overview_indexIcon_emperor_up.dds",
        down = "EsoUI/Art/Campaign/overview_indexIcon_emperor_down.dds",
        over = "EsoUI/Art/Campaign/overview_indexIcon_emperor_over.dds",
    },
	[CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_RANKING] =
	{
		name = "AP Ranking",
        up = "EsoUI/Art/icons/achievements_indexicon_alliancewar_up.dds",
        down = "EsoUI/Art/icons/achievements_indexicon_alliancewar_down.dds",
        over = "EsoUI/Art/icons/achievements_indexicon_alliancewar_over.dds",
	},
	[CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_TIER_INFO] =
	{
		name = "Char Tier Info",
        up = "EsoUI/Art/icons/achievements_indexicon_alliancewar_up.dds",
        down = "EsoUI/Art/icons/achievements_indexicon_alliancewar_down.dds",
        over = "EsoUI/Art/icons/achievements_indexicon_alliancewar_over.dds",
	},
	--[CAMPAIGN_OVERVIEW_TYPE_BG_SYLES] =
	--{
	--	name = "Battleground Styles",
    --    up = "EsoUI/Art/icons/achievements_indexicon_alliancewar_up.dds",
    --    down = "EsoUI/Art/icons/achievements_indexicon_alliancewar_down.dds",
    --    over = "EsoUI/Art/icons/achievements_indexicon_alliancewar_over.dds",	
	--},
}

function BSCARI:HookInitializeCategories()
	local function CategorySetup(node, control, overviewType, down)
		local info = CAMPAIGN_OVERVIEW_TYPE_INFO[overviewType]
		control.text:SetModifyTextType(MODIFY_TEXT_TYPE_UPPERCASE)
		control.text:SetText(info.name)
		control.overviewType = overviewType
		control.icon:SetTexture(down and info.down or info.up)
		control.iconHighlight:SetTexture(info.over)
		ZO_IconHeader_Setup(control, down)
	end
	local function CategorySelected(control, overviewType, selected, reselectingDuringRebuild)
		if selected then
			CAMPAIGN_OVERVIEW:ChangeCategory(overviewType)
		end
		CategorySetup(nil, control, overviewType, selected)
	end	
	CAMPAIGN_OVERVIEW.tree.templateInfo["ZO_CampaignOverviewType"].setupFunction = CategorySetup
	CAMPAIGN_OVERVIEW.tree.templateInfo["ZO_CampaignOverviewType"].selectionFunction = CategorySelected
end
function BSCARI:HookRefreshCategories()
	BSCARI:HookInitializeCategories()
	CAMPAIGN_OVERVIEW.tree:Reset()
	for categoryType, categoryInfo in ipairs(CAMPAIGN_OVERVIEW_TYPE_INFO) do
		if not categoryInfo.visible or categoryInfo.visible() then
			CAMPAIGN_OVERVIEW.tree:AddNode("ZO_CampaignOverviewType", categoryType)
		end
    end	
    CAMPAIGN_OVERVIEW.tree:Commit()			
	return true -- do not run original code
end
function BSCARI:HookChangeCategory()
	local overviewType = CAMPAIGN_OVERVIEW.overviewType
    if not CAMPAIGN_BONUSES_FRAGMENT or not CAMPAIGN_EMPEROR_FRAGMENT or not CAMPAIGN_SCORING_FRAGMENT then
        return
    end
    if overviewType == CAMPAIGN_OVERVIEW_TYPE_SCORING then
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_BONUSES_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_EMPEROR_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one
        --CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one		
        CAMPAIGN_OVERVIEW_SCENE:AddFragment(CAMPAIGN_SCORING_FRAGMENT)
    elseif overviewType == CAMPAIGN_OVERVIEW_TYPE_BONUSES then
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_SCORING_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_EMPEROR_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one
        --CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one		
        CAMPAIGN_OVERVIEW_SCENE:AddFragment(CAMPAIGN_BONUSES_FRAGMENT)
    elseif overviewType == CAMPAIGN_OVERVIEW_TYPE_EMPEROR then
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_SCORING_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_BONUSES_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one
        --CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one		
        CAMPAIGN_OVERVIEW_SCENE:AddFragment(CAMPAIGN_EMPEROR_FRAGMENT)
	elseif overviewType == CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_RANKING then
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_SCORING_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_BONUSES_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_EMPEROR_FRAGMENT)		
        --CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one	
        CAMPAIGN_OVERVIEW_SCENE:AddFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one	
	elseif overviewType == CAMPAIGN_OVERVIEW_TYPE_ALLIANCE_TIER_INFO then
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_SCORING_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_BONUSES_FRAGMENT)
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_EMPEROR_FRAGMENT)		
        --CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one
        CAMPAIGN_OVERVIEW_SCENE:AddFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one	
	--elseif overviewType == CAMPAIGN_OVERVIEW_TYPE_BG_SYLES then
     --   CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_SCORING_FRAGMENT)
     --   CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_BONUSES_FRAGMENT)
    --    CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(CAMPAIGN_EMPEROR_FRAGMENT)		
        --CAMPAIGN_OVERVIEW_SCENE:AddFragment(BSCARI.ALLIANCE_BGSTYLEVIEW_FRAGMENT) --// new one
   --     CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_TIERVIEW_FRAGMENT) --// new one	
   --     CAMPAIGN_OVERVIEW_SCENE:RemoveFragment(BSCARI.ALLIANCE_POINTSVIEW_FRAGMENT) --// new one
	else
		-- NOTHING
    end		
	--return true -- do not run original code
	BSCARI:UpdateRotW()
end
function BSCARI:HookUpdateCampaignWindows()
	for i, window in ipairs(CAMPAIGN_SELECTOR.campaignWindows) do
        window:SetCampaignAndQueryType(CAMPAIGN_SELECTOR:GetCampaignId(), CAMPAIGN_SELECTOR.selectedQueryType)
    end
	return true -- do not run original code
end

function BSCARI:PlayAnnounce(text)
	CENTER_SCREEN_ANNOUNCE:AddMessage(0, CSA_CATEGORY_LARGE_TEXT, SOUNDS.LEVEL_UP, "Alliance Reward", zo_strformat("<<1>> ", text), "/esoui/art/icons/achievement_battlegrounds_001.dds", "EsoUI/Art/Achievements/achievements_iconBG.dds", nil, nil, 4000)
end
-------------------------------------------------------------------------------------------------
-- Tier/AP Controls 
-------------------------------------------------------------------------------------------------
local function CreateControls()
	local fontSize = 18
	local fontStyle = ZoFontGame:GetFontInfo()
	local fontWeight = "soft-shadow-thin"
	local font = string.format("%s|$(KB_%s)|%s", fontStyle, fontSize, fontWeight)
	
	local parentStatusbar = ZO_CampaignScoringTierProgressStatusBar
	BSCARI.TierInfoLabel = WINDOW_MANAGER:CreateControl(nil, parentStatusbar, CT_LABEL)
	BSCARI.TierInfoLabel:SetAnchor(CENTER, parentStatusbar, CENTER, 0, 20) 
	BSCARI.TierInfoLabel:SetFont(font)
	
	local parentRankingBar = ZO_CampaignAvARankXPBar	
	--
	BSCARI.APBarControl = WINDOW_MANAGER:CreateControlFromVirtual("TestAPBar", parentRankingBar, "ZO_ArrowStatusBarWithBG")
	BSCARI.APInfoBar = ZO_WrappingStatusBar:New(BSCARI.APBarControl)
	ZO_StatusBar_SetGradientColor(BSCARI.APBarControl, ZO_AVA_RANK_GRADIENT_COLORS)	
	BSCARI.APBarControl:SetAnchor(LEFT, parentRankingBar, RIGHT, 20, 0) 
	--
	BSCARI.APInfoLable = WINDOW_MANAGER:CreateControl(nil, BSCARI.APBarControl, CT_LABEL)
	BSCARI.APInfoLable:SetAnchor(CENTER, BSCARI.APBarControl, CENTER, 0, 20) 
	BSCARI.APInfoLable:SetFont(font)
	-- 
	BSCARI.CurrentAPInfoLable = WINDOW_MANAGER:CreateControl(nil, parentRankingBar, CT_LABEL)
	BSCARI.CurrentAPInfoLable:SetAnchor(CENTER, parentRankingBar, CENTER, 0, 20) 
	BSCARI.CurrentAPInfoLable:SetFont(font)
	
	-- Lable RotW
	BSCARI.RotWLable = WINDOW_MANAGER:CreateControl(nil, BSCARI.APBarControl, CT_LABEL)
	BSCARI.RotWLable:SetAnchor(LEFT, BSCARI.APBarControl, RIGHT, 10, 10) 
	BSCARI.RotWLable:SetFont(font)	
		
	-- Test Button
	BSCARI.ButtonAlert = WINDOW_MANAGER:CreateControlFromVirtual(nil, parentStatusbar, "ZO_DefaultButton")
    BSCARI.ButtonAlert:SetAnchor(LEFT, parentStatusbar, RIGHT, 0, 30)
    BSCARI.ButtonAlert:SetWidth(100)
    BSCARI.ButtonAlert:SetText("Test Alert")
    BSCARI.ButtonAlert:SetHandler("OnClicked", function() 		
		local currentTier, nextTierProgress, nextTierTotal = GetPlayerCampaignRewardTierInfo(GetAssignedCampaignId())
		local info = "["..currentTier.."/3] Points to next [" .. ZO_CommaDelimitDecimalNumber(nextTierProgress).."/"..ZO_CommaDelimitDecimalNumber(nextTierTotal).."]"
		if currentTier == 3 then
			info = "["..currentTier.."/3] Max Alliance Tier Level Reached!"
		end
		BSCARI:PlayAnnounce(info)		
	end)
	-- CheckBox
	BSCARI.CheckBoxAlert = WINDOW_MANAGER:CreateControlFromVirtual(nil, parentStatusbar, "ZO_Options_Checkbox")
	BSCARI.CheckBoxAlert.data = { }
	BSCARI.CheckBoxAlert.data.enabled = true
	BSCARI.CheckBoxAlert.data.text = "Tier Alert"
	BSCARI.CheckBoxAlert.data.tooltipText = "Show Alert every Tier you reach!"
	
    BSCARI.CheckBoxAlert:SetAnchor(LEFT, parentStatusbar, RIGHT, 15, 0)	
	BSCARI.CheckBoxAlert:SetWidth(300)
		
	local lblNameControl = GetControl(BSCARI.CheckBoxAlert, "Name")
	lblNameControl:SetText(BSCARI.CheckBoxAlert.data.text);
	if BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert then 
		lblNameControl:SetColor(ZO_SELECTED_TEXT:UnpackRGBA())
	else
		lblNameControl:SetColor(ZO_DISABLED_TEXT:UnpackRGBA())
	end	
	
	BSCARI.CboxControl = GetControl(BSCARI.CheckBoxAlert, "Checkbox")
	ZO_CheckButton_SetCheckState(BSCARI.CboxControl, BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert)				
    BSCARI.CboxControl:SetHandler("OnMouseUp", function(checkboxControl)	
		local NameControl = GetControl(BSCARI.CheckBoxAlert, "Name")	
		if ZO_CheckButton_IsChecked(checkboxControl) then
			BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert = true
			NameControl:SetColor(ZO_SELECTED_TEXT:UnpackRGBA())
		else
			BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert = false
			NameControl:SetColor(ZO_DISABLED_TEXT:UnpackRGBA())
		end
	end)
    BSCARI.CboxControl:SetHandler("OnMouseExit", function(checkboxControl)	
		ClearTooltip(InformationTooltip)		
		local NameControl = GetControl(BSCARI.CheckBoxAlert, "Name")
		if ZO_CheckButton_IsChecked(checkboxControl) then
			NameControl:SetColor(ZO_SELECTED_TEXT:UnpackRGBA())
		else
			NameControl:SetColor(ZO_DISABLED_TEXT:UnpackRGBA())
		end
	end)
	
	BSCARI.CheckBoxAlert:SetHandler("OnMouseUp", function(control) 
		local NameControl = GetControl(control, "Name")	
		local checkboxControl = GetControl(control, "Checkbox")
		ZO_CheckButton_OnClicked(checkboxControl)
		if ZO_CheckButton_IsChecked(checkboxControl) then
			BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert = true
			NameControl:SetColor(ZO_SELECTED_TEXT:UnpackRGBA())
		else
			BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlert = false
			NameControl:SetColor(ZO_DISABLED_TEXT:UnpackRGBA())
		end		
	end)
    BSCARI.CheckBoxAlert:SetHandler("OnMouseExit", function(control) 
		ClearTooltip(InformationTooltip)		
		local NameControl = GetControl(control, "Name")		
		local checkboxControl = GetControl(control, "Checkbox")			
		if ZO_CheckButton_IsChecked(checkboxControl) then
			NameControl:SetColor(ZO_SELECTED_TEXT:UnpackRGBA())
		else
			NameControl:SetColor(ZO_DISABLED_TEXT:UnpackRGBA())
		end
	end)
	-- end checkox
end
local function HookUpdateRewardTier()
	local currentTier, nextTierProgress, nextTierTotal = GetPlayerCampaignRewardTierInfo(GetAssignedCampaignId())
	local info = " [" ..zo_strformat(SI_NUMBER_FORMAT, nextTierProgress).."/"..zo_strformat(SI_NUMBER_FORMAT, nextTierTotal).."]"	
	local color = "|cb30000"	
	if currentTier == 1 then
		color = "|cff9933" 
	elseif currentTier == 2 then
		color = "|cfcd25d" 
	elseif currentTier == 3 then
		color = "|c00b300" 
		info = " Max Tier Reached!"
	end
	BSCARI.TierInfoLabel:SetText(color.." [" .. currentTier .. "/3]"..info.." |r " )
end
local function GetCurrentRankProgress()
    local rankPoints = GetUnitAvARankPoints("player")
    local _, _, rankStartsAt, nextRankAt = GetAvARankProgress(rankPoints)
    if rankPoints >= nextRankAt then
        local rank = GetUnitAvARank("player")
        local lastRankPoints = GetNumPointsNeededForAvARank(rank - 1)
        local maxRankPoints = GetNumPointsNeededForAvARank(rank)
        local fullRankPoints = maxRankPoints - lastRankPoints
        return fullRankPoints, fullRankPoints
    else
        return rankPoints - rankStartsAt, nextRankAt - rankStartsAt
    end
end
local function HookAvARankRefresh()
	local rankPoints = GetUnitAvARankPoints("player")
	local max_points = 64680000	 
	local percent = rankPoints / max_points * 100
	BSCARI.APInfoLable:SetText(string.format("%.4f%% Completed ["..zo_strformat(SI_NUMBER_FORMAT, rankPoints).." / "..zo_strformat(SI_NUMBER_FORMAT, max_points).."]", percent))
	BSCARI.APInfoBar:SetValue(0, rankPoints, max_points, true, true)	
	local APcurrent, APmax = GetCurrentRankProgress()
	local APPercent = APcurrent / APmax * 100
	BSCARI.CurrentAPInfoLable:SetText(string.format("%.2f%% Completed ["..zo_strformat(SI_NUMBER_FORMAT, APcurrent).." / "..zo_strformat(SI_NUMBER_FORMAT, APmax).."]", APPercent))
end
local icon = '|t16:16:/esoui/art/currency/alliancepoints.dds|t'
local APGain = 0
local AP_DelayedPrint = 0
local APR_DelayedPrint = 0
local function RankPointUpdate(_, unitTag, rankPoints, difference) 
	HookAvARankRefresh()
	BSCARI:UpdateCharData()
	if not BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAPInfoChat then return end	
	if unitTag == "player" then
		if APGain > 1000 then		
			local APG = zo_strformat(SI_NUMBER_FORMAT, APGain)
			local APD = zo_strformat(SI_NUMBER_FORMAT, difference)		
			d(zo_strformat("<<3>> |c31c441AP gain: |cffff66 <<1>> |c31c441APR gain: |cffff66 <<2>>", APG, APD, icon))
		else
			AP_DelayedPrint = AP_DelayedPrint + APGain
			APR_DelayedPrint = APR_DelayedPrint + difference
		end
				
		if AP_DelayedPrint > 1000 then
			local APG = zo_strformat(SI_NUMBER_FORMAT, AP_DelayedPrint)
			local APD = zo_strformat(SI_NUMBER_FORMAT, APR_DelayedPrint)		
			d(zo_strformat("<<3>> |c31c441AP gain: |cffff66 <<1>> |c31c441APR gain: |cffff66 <<2>> |c31c441(collected)", APG, APD, icon))
			AP_DelayedPrint = 0
			APR_DelayedPrint = 0
		end		
	end
end
local function AlliancePointUpdate(eventCode, alliancePoints, playSound, difference, reason)	
	if difference > 0 then		
		APGain = difference			
	end
end
local function OnCombatState(_, inCombat)
	if not inCombat then	
		if AP_DelayedPrint > 0 then
			local APG = zo_strformat(SI_NUMBER_FORMAT, AP_DelayedPrint)
			local APD = zo_strformat(SI_NUMBER_FORMAT, APR_DelayedPrint)		
			CHAT_ROUTER:AddSystemMessage(zo_strformat("<<3>> |c31c441AP gain: |cffff66 <<1>> |c31c441APR gain: |cffff66 <<2>> |c31c441(collected)", APG, APD, icon))
			AP_DelayedPrint = 0
			APR_DelayedPrint = 0	
		end
	end
end
-------------------------------------------------------------------------------------------------
-- Low PoP Info Stuff
-------------------------------------------------------------------------------------------------
BSCARI.CAMPAIGN_IDS = { }
--EVENT_CAMPAIGN_UNDERPOP_BONUS_CHANGE_NOTIFICATION (*integer* _campaignId_)
function BSCARI:BSCGetCampaignIdList()
	--d("BSCARI:BSCGetCampaignIdList()")
	BSCARI.CAMPAIGN_IDS = { }
	for selectionIndex, campaignData in pairs(CAMPAIGN_BROWSER_MANAGER.selectionCampaignList) do	
		local _campaignId_ = campaignData.id
		if not campaignData.isImperialCityCampaign then	
			BSCARI.CAMPAIGN_IDS[_campaignId_] = { }		
			for _alliance_ = 1, 3 do
				BSCARI.CAMPAIGN_IDS[_campaignId_][_alliance_] = false
			end
		end
	end --/script d(BSCAllianceRanking.CAMPAIGN_IDS)
end
--[[
function BSCARI:BSCGetCampaignIdList()
	BSCARI.CAMPAIGN_IDS = { }	
    for selectionIndex = 1, GetNumSelectionCampaigns() do		
		local campaignId = GetSelectionCampaignId(selectionIndex)		
		if not IsImperialCityCampaign(campaignId) then	
			BSCARI.CAMPAIGN_IDS[campaignId] = { }		
			for _alliance_ = 1, 3 do
				BSCARI.CAMPAIGN_IDS[campaignId][_alliance_] = false
			end
		end		
	end	
end
--]]
local function OnUPoPBonusChangeNotify( _, campaignId)	
	BSCARI:CheckLowPoP()
	if not BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlertLowPop then return end
	--[[
	if BSCARI.CAMPAIGN_IDS[campaignId] == nil then 
		d("OnUPoPBonusChangeNotify was nil campaignId["..campaignId.."]")
		for _alliance_ = 1, 3 do
			if IsUnderpopBonusEnabled(campaignId, _alliance_) then
				CHAT_ROUTER:AddSystemMessage(zo_strformat("D START AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(campaignId)))
				PlaySound(SOUNDS.ENLIGHTENED_STATE_GAINED)
			end
		end
		return
	end
	--]]
	for _alliance_ = 1, 3 do
		if IsUnderpopBonusEnabled(campaignId, _alliance_) then
			--if BSCARI.CAMPAIGN_IDS[campaignId][_alliance_] == false then 
				--BSCARI.CAMPAIGN_IDS[campaignId][_alliance_] = true		
				CHAT_ROUTER:AddSystemMessage(zo_strformat("START AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(campaignId)))
				PlaySound(SOUNDS.ENLIGHTENED_STATE_GAINED)
				--CENTER_SCREEN_ANNOUNCE:AddMessage(nil, CSA_CATEGORY_LARGE_TEXT, SOUNDS.ALLIANCE_POINT_TRANSACT, zo_strformat("<<1>>",GetAllianceColor(_alliance_):Colorize("AP BOOST")), zo_strformat("AP BOOST FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), "/esoui/art/currency/alliancepoints.dds", "EsoUI/Art/Achievements/achievements_iconBG.dds", nil, nil, 4000)		
			--end
		else
			--if BSCARI.CAMPAIGN_IDS[campaignId][_alliance_] == true then 
				--BSCARI.CAMPAIGN_IDS[campaignId][_alliance_] = false
				CHAT_ROUTER:AddSystemMessage(zo_strformat("END AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(campaignId)))
				--PlaySound(SOUNDS.ENLIGHTENED_STATE_LOST)
			--end
		end
	end
end
local function TestLowPoPBonus()	
	BSCARI:BSCGetCampaignIdList()
	if GetAssignedCampaignId() > 0 then
		GetCampaignHoldingScoreValues(GetAssignedCampaignId())
		GetCampaignUnderdogLeaderAlliance(GetAssignedCampaignId())	
	end		
	QueryCampaignSelectionData()
	QueryCampaignLeaderboardData(ALLIANCE_NONE)
	for _campaignId_, info in pairs(BSCARI.CAMPAIGN_IDS) do	
		GetCampaignHoldingScoreValues(_campaignId_)
		GetCampaignUnderdogLeaderAlliance(_campaignId_)		
		CAMPAIGN_SCORING:UpdateRewardTier()
		CAMPAIGN_SCORING:UpdateScores()		
		for _alliance_ = 1, 3 do
			if IsUnderpopBonusEnabled(_campaignId_, _alliance_) then
				if BSCARI.CAMPAIGN_IDS[_campaignId_][_alliance_] == false then 
					BSCARI.CAMPAIGN_IDS[_campaignId_][_alliance_] = true
					--d(zo_strformat("START AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(_campaignId_)))
					if BSCARI.SVA.SETTING[BSCARI.CurrentCharID].bAlertLowPop then 
						CHAT_ROUTER:AddSystemMessage(zo_strformat("START AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(_campaignId_)))
						PlaySound(SOUNDS.ENLIGHTENED_STATE_GAINED)
					end
				end
			else
				if BSCARI.CAMPAIGN_IDS[_campaignId_][_alliance_] == true then 
					BSCARI.CAMPAIGN_IDS[_campaignId_][_alliance_] = false
					--d(zo_strformat("END AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(_alliance_):Colorize(GetAllianceName(_alliance_)), GetCampaignName(_campaignId_)))
				end
			end
		end
	end
end
function BSCARI:UpdateRotW()
    local cooldownRotWEpoch = BSCARI.SVA.cooldownRotWTime
    local output = "|cE9C62ARotW: "
    if cooldownRotWEpoch == nil then -- If there is no data from previous
        output = output .. " |cffcc00-|r"
    else
        local cooldownRemainingSeconds = os.difftime(cooldownRotWEpoch, os.time())
        if cooldownRemainingSeconds <= 0 then -- If the coffer is out of cooldown
            output = output .. " |t23:23:/esoui/art/icons/crafting_runecrafter_potion_sp_001.dds|t"
        else -- If the coffer is on cooldown
            local timediff, secondsToUpdate = FormatTimeSeconds(cooldownRemainingSeconds, TIME_FORMAT_STYLE_SHOW_LARGEST_UNIT, TIME_FORMAT_PRECISION_SECONDS, TIME_FORMAT_DIRECTION_DESCENDING)
            output = output .. "|cE9C62A" .. timediff
        end
    end
    BSCARI.RotWLable:SetText(output)
end
local function InvetorySingleSlotUpdate(_, bagId, slotId)
	if GetItemId(bagId, slotId) == 134618 then -- 134618 RotW Geode id
        if BSCARI.SVA.cooldownRotWTime == nil or BSCARI.SVA.cooldownRotWTime <= os.time() then
			BSCARI.SVA.cooldownRotWTime = os.time() + 72000
			BSCARI:UpdateRotW()
        end
    end
end
-------------------------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------------------------
local function OnPlayerActivated()	
    EVENT_MANAGER:UnregisterForEvent(BSCARI.Name, EVENT_PLAYER_ACTIVATED)
	-- ZO_PreHook
	-- ZO_PostHook	
	-- Adding New Option to the UI
	BSCARI:HookRefreshCategories()	
	ZO_PostHook(CAMPAIGN_OVERVIEW, "ChangeCategory", function() BSCARI:HookChangeCategory() end)
	
	if IsUnitPvPFlagged('player') then
		QueryCampaignSelectionData()
		QueryCampaignLeaderboardData(GetUnitAlliance('player'))
		CAMPAIGN_SCORING:UpdateRewardTier()
		CAMPAIGN_SCORING:UpdateScores()	
		RequestTributeCampaignData()		
	end
	zo_callLater(function() TestLowPoPBonus() end, 3000)
end

-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
-- //////////////////////////////////////////////// --- Init -- //////////////////////////////////////////////////////
-- ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
local function SlashCommand(text)
	local ftext = zo_strlower(text)
	if ftext == 'test' then	
		d("TestLowPoPBonus")
		BSCARI:BSCGetCampaignIdList()
		TestLowPoPBonus()
	elseif ftext == 'score' then
		d("TestScore")	
		BSCARI:BSCGetCampaignIdList()
		for campaignId, info in pairs(BSCARI.CAMPAIGN_IDS) do	
			local keepScore, resourceValue, outpostValue, defensiveScrollValue, offensiveScrollValue = GetCampaignHoldingScoreValues(campaignId)
			local underdogLeaderAlliance = GetCampaignUnderdogLeaderAlliance(campaignId)
			for i = 1, NUM_ALLIANCES do
				local isUnderpop = IsUnderpopBonusEnabled(campaignId, i)
				if isUnderpop then					
					d(zo_strformat("START AP BOOST [<<2>>] FOR [<<1>>]", GetAllianceColor(i):Colorize(GetAllianceName(i)), GetCampaignName(campaignId)))
				end
			end
		end
	else
		d(text)
		-- Home Keeps
		--  3 -  8 DC
		--  9 - 14 EP
		-- 15 - 20 AD
		for i = 1, GetNumKeeps() do
			local keepId, bgContext = GetKeepKeysByIndex(i)
			if GetKeepType(keepId) == KEEPTYPE_KEEP then
				d(keepId.." - "..bgContext.." - "..GetKeepName(keepId))
			end
		end
	end
end

function BSCARI.init(event, addonName)	
	if addonName ~= BSCARI.Name then
		return 
	end
	
	QueryCampaignSelectionData()
	QueryCampaignLeaderboardData(ALLIANCE_NONE)		
	CAMPAIGN_SCORING:UpdateRewardTier()
	CAMPAIGN_SCORING:UpdateScores()	
	RequestTributeCampaignData()	
	BSCARI.CurrentCharID = GetCurrentCharacterId()	
	EVENT_MANAGER:UnregisterForEvent(BSCARI.Name, 	EVENT_ADD_ON_LOADED)	
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_PLAYER_ACTIVATED, OnPlayerActivated)		
	BSCARI.SVA = ZO_SavedVars:NewAccountWide(BSCARI.SavedVar, BSCARI.Version, nil, defaultSavedVarsAccount)
	if BSCARI.SVA.SETTING[BSCARI.CurrentCharID] == nil then 
		BSCARI.SVA.SETTING[BSCARI.CurrentCharID] = { bAlert = false, bAlertBuff = false, bEnableUI = false, bAPInfoChat = false, offsetX = 0, offsetY = 0, LOCK_UI = false, PLAY_SOUND = false, bAlertLowPop = false } 
	end
			
	-- Lables & Total AP Bar
	CreateControls()		
	ZO_PostHook(CAMPAIGN_SCORING, "UpdateRewardTier", HookUpdateRewardTier)
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_CAMPAIGN_LEADERBOARD_DATA_CHANGED, function() HookUpdateRewardTier() end) --	
	ZO_PostHook(CAMPAIGN_OVERVIEW, "ChangeCategory", HookAvARankRefresh)
	ZO_PostHook(CAMPAIGN_BROWSER, "SelectAssignedCampainRulesetNode", HookAvARankRefresh)	 
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_RANK_POINT_UPDATE, RankPointUpdate)  
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_ALLIANCE_POINT_UPDATE, AlliancePointUpdate)  	
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_PLAYER_COMBAT_STATE, OnCombatState)	
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_CAMPAIGN_UNDERPOP_BONUS_CHANGE_NOTIFICATION, OnUPoPBonusChangeNotify)  
	
	--
	EVENT_MANAGER:RegisterForEvent(BSCARI.Name.."ROTW", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, InvetorySingleSlotUpdate)
    EVENT_MANAGER:AddFilterForEvent(BSCARI.Name.."ROTW", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_BAG_ID, BAG_BACKPACK)
    EVENT_MANAGER:AddFilterForEvent(BSCARI.Name.."ROTW", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_INVENTORY_UPDATE_REASON, INVENTORY_UPDATE_REASON_DEFAULT)
    EVENT_MANAGER:AddFilterForEvent(BSCARI.Name.."ROTW", EVENT_INVENTORY_SINGLE_SLOT_UPDATE, REGISTER_FILTER_IS_NEW_ITEM, true)
	
	BSCARI:InitAbuffInfo()
	BSCARI:UpdateCharData()	
	
	BSCARI:InitMenu()
	-- Command
	SLASH_COMMANDS['/bscari'] = SlashCommand
end

EVENT_MANAGER:RegisterForEvent(BSCARI.Name, EVENT_ADD_ON_LOADED, BSCARI.init)